<?php
/*
* SQL class
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
class SQL_DataBase {

	function SQL_DataBase() {
		//check for database existence and create blank database if necessary
		if(!$this->db_exist()) {
			$this->create_new_db();
			if($this->db_exist()) {
				echo "Done!<br \>\n";
				flush();
			} else {
				echo "Failed!<br \>\n";
				flush();
			}
		}
	}

	function create_new_db() {
		
		echo "Try to create new ".$this->db_type." Database...<br \>\n";
		flush();
		if($this->db_type != "SQLite") { //SQLite does not need to create a database
			$this->query("CREATE DATABASE ".$this->db);
		}
		$this->query("CREATE TABLE user_settings (user char(16), password char(32), titlebar char(128),
							   lang char(8), theme char(16), incoming char(64), max_download_nr char(4),
							   groups char(128), page_refresh char(4), max_download_vol char(8), max_name_len char(4))");
		$this->query("INSERT INTO user_settings (user, password, titlebar, lang, theme, incoming, groups, page_refresh, max_download_nr, max_download_vol, max_name_len)
		VALUES ('admin', 'd41d8cd98f00b204e9800998ecf8427e', 'vd:s:umanage:gmanage:logout', 'en', 'default','./', 'admin:31', '-1', '9999','99999999', '80')");
		$this->query("CREATE TABLE downloads (owner char(16), nr char(8), hash char(32))");
		$this->query("CREATE TABLE group_settings (groups char(16), incoming char(64), max_download_nr char(4), max_download_vol char(8))");
		$this->query("CREATE TABLE searches (user char(16), searchnum  int)");
	}
}

/*
* SQLite wrapper class
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
class SQLite extends SQL_DataBase {

	var $db = NULL;
	var $resource = NULL;
	var $db_type = "SQLite";
	
	function SQLite($db = "./gmui.db") {
		$this->db = $db;
		
		$this->SQL_DataBase();
	}
	
	function db_exist() {
		$db_exist = TRUE;
		if(!file_exists($this->db)) {
			echo "SQLite database file '".$this->db."' does not exist!<br />\n";
			$db_exist = FALSE;
		} elseif(!is_readable($this->db)) {
			die ("SQLite database file '".$this->db."' is not readable!<br />");
		} elseif(!is_writeable($this->db)) {
			die ("SQLite database file '".$this->db."' is not writeable!<br />");
		}
		return $db_exist;
	}
	
	function open() {
		$this->resource = sqlite_open($this->db) OR die ("Could not open Database!");
	}
	
	function close() {
		sqlite_close($this->resource);
		$this->resource = NULL;
	}
	
	//this function should be private, database need to be opened before and closed afterwards
	function query($query)
	{
		$this->open();
		$result = sqlite_query($query, $this->resource) OR die( sqlite_error().'<br> SQL:'.$query);
		$this->close();
		return $result;
	}
	
	function fetch_array($result) {
		return sqlite_fetch_array($result, SQLITE_ASSOC);
	}
	
	function num_rows($result)
	{
		return sqlite_num_rows($result);
	}
}

/*
* MySQL wrapper class
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
class MySQL extends SQL_DataBase {

	var $db_type = "MySQL";
	var $user = NULL;
	var $passwd = NULL;
	var $host = NULL;
	var $db = NULL;
	var $resource = NULL;
	
	function MySQL($user = "gmui", $passwd = "", $host = "localhost", $db = "gmui") {
		$this->user = $user;
		$this->passwd = $passwd;
		$this->host = $host;
		$this->db = $db;
		
		$this->SQL_DataBase();
	}
	
	function db_exist() {
		$db_exist = FALSE;
		$this->open();
		$result =  mysql_query("SHOW DATABASES"); //or $this->query()
		while($row = $this->fetch_array($result)) {
			if($row['Database'] == $this->db) { $db_exist = TRUE; }
		}
		$this->close();
		return $db_exist;
	}
	
	function open() {
		$this->resource = mysql_connect($this->host, $this->user, $this->passwd) OR die ("Could not connect to Database!");
	}
	
	function close() {
		mysql_close($this->resource);
		$this->resource = NULL;
	}
	
	//this function should be private, database need to be opened before and closed afterwards
	function query($query)
	{
		$this->open();
		mysql_select_db($this->db);
		$result = mysql_query($query, $this->resource) OR die( mysql_error().'<br> SQL:'.$query);
		$this->close();
		return $result;
	}
	
	function fetch_array($result) {
		return mysql_fetch_array($result, MYSQL_ASSOC);
	}
	
	function num_rows($result)
	{
		return mysql_num_rows($result);
	}
}
?>