<?php
/**
* File class
* 
* Represents an edonkey file (upload)
*
@author Moritz Warning <mwarning@users.sourceforge.net>
*/

class MLD_Upload {

	var $isvalid = TRUE;
	
/**
* MD4 Hash
*/
	var $hash = NULL;

/**
* Network 
*/
	var $network = NULL;

/**
* IP - Address
*/
	var $ip = NULL;

/**
* mldonkey Number
*/
	var $nr = NULL;

/**
* Amount uploaded in byte
*/
	var $uploaded = NULL;

/**
* Amount downloaded in byte
*/
	var $downloaded = NULL;

/**
* Name of file
*/
	var $filename = NULL;

/**
* Upload user
*/
	var $user = NULL;

/**
* Upload user's client
*/
	var $client = NULL;

/**
* Upload user's score
*/
	var $score = NULL;


	function MLD_Upload($line = NULL)
	{
		if(isset($line) && preg_match("/^\[/", $line) && !preg_match("/^\[ Num/", $line)) {
			$line = preg_replace("/\W*\]/", "", $line); //remove all not a-zA-Z0-9 chars ,  depends of system
			$line = preg_replace("/\s+/", " ", $line); //unique the spaces
			
			$temp = preg_split("/(Name\s+:)|(Rating\s*:)|(IP\s*:)|(client\s*:)|(downloaded\s*:)|(uploaded\s*:)/",$line);
			//$this->name is transmitted in a second line and not parsed and set here, setFilename set it
			preg_match("/([A-Za-z]+)\s*(\d+)/",$temp[0],$temp1);
			$this->network = $temp1[1];
			$this->nr = (int) $temp1[2];
			$this->score = (int) $temp[2];
			$this->ip = $temp[3];
			if(preg_match("/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}:\d{1,4}/",$temp[3])) {
				$this->ip = $temp[3];
			} else {
				$this->ip = "firewalled";
			}
			$this->user = $temp[1];
			$this->client = $temp[4];
			$this->downloaded = (float) $temp[5];
			$this->uploaded = (float) $temp[6];
			
		} else { $this->isvalid = FALSE; }
	}

	function setFilename($filename)
	{
		$this->name = $filename;
	}
}