<?php

/**
* Shared File in Upstats class
* 
* Represents a shared file entry in shared statistics by MLDonkey
*
* @author   Moritz Warning <mwarning@users.sourceforge.net>
*/

class MLD_Upstats {

	var $isvalid = FALSE;

	var $requests = NULL;

	var $uploaded = NULL;

	var $percent = NULL;

	var $name = NULL;

/**
* Constructor for MLD_Upstats class
*
* Accepts a line, and will set the appropriate vars is possible
*
* @author   CJ Kucera <zuul@NOSPAM.apocalyptech.com>
* @author Moritz Warning
*/
	function MLD_Upstats($line = NULL)
	{
		if(!isset($line)) { return; }
	
		if (preg_match("/\s*(\d+)\s+\|\s+(\d[\d.]*\w{0,2})\s*\|\s*(\d[\d.]*%)\s*\|\s*(.+)\s*/", $line, $found)) {
			$this->requests = (int) $found[1];
			$this->uploaded = (float) byteSize($found[2]);
			$this->percent = (float) $found[3];
			$this->name = $found[4];
			$this->isvalid = TRUE;	
		}
	}
}
?>