<?php
/**
* Download files by links
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function dllink()
{
	$content = NULL;
		
	// Print form to add links
	$_SESSION['headline'] = _("Download Links");
	$content .= '<form method="post" action="index.php">'.NL;
	
	$content .= '<input type="hidden" name="CORE_OP" value="dllink_action" />'.NL;
	$content .= _("Paste Links").":".BBN;
	
	$content .= '<table width="70%">'.NL;
	$content .= '<tr><td colspan="2"><textarea name="link_string" rows="12" style="width:100%;" /></textarea><td></tr>'.NL;
	$content .= '<tr><td align="left">'.NL;
	$content .=  getUserSelection().NL;
	$content .= '&nbsp;<input type="submit" name="download" value="' . _("Download") . "\" />\n";
	$content .= '&nbsp;<input type="submit" name="parse" value="' . _("Parse") . "\" />\n";
	$content .= '&nbsp;<input type="checkbox" name="force_http" value="TRUE">&nbsp;'._("Force http")."</td>\n";
	$content .= '<td align="right"><input type="reset" value="'._("Reset")."\"></td>\n";
	$content .= '</tr></table>';

	$content .= "</form>".BBN;
	
	return $content;
}

/*
* select_links displays a list of links for selection
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function select_links($link_array) {
	
	$need_domain = FALSE;
	$content = NULL;
	$type_link_array = link_sorter($link_array, TRUE);
	
	$content .= checkboxJavascript("link_array[]");
	$content .= '<form name="links" method="post" action="index.php">'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="dllink_action" />'.NL;
	$content .= '<table cellspacing="0" cellpadding="2" border="0">';
	
	//print  All | None | Invert | Range
        $content .= '<tr><td colspan="2">'.NL;
        $content .= checkboxLinks("links");
        $content .= "</td></tr>\n";
	
	$c = 0;
	foreach($type_link_array as $type => $link_array) {
		if(count($link_array) == 0) { continue; }
		
		$content .= '<tr class="bg_dark"><th>&nbsp;</th><th>'._("Links").': '.$type.'</th></tr>'.NL;
		
		foreach($link_array as $link) {
			$c++;
			
			if($c%2 == 0) { $content .= '<tr class="list">'; }
			else { $content .= '<tr class="alt_list">'; }
			
			$content .= '<td><input type="checkbox" name="link_array[]" value="'.$link.'" /></td>'.NL;
			
			if(strtolower(substr($link, 0, 7)) == 'http://') {
				$content .= '<td><a href="'.$link.'" target="_blank">'.$link."</a></td>";
			} else { $content .= "<td>$link</td>"; }
			
			$content .= "</tr>\n";
		}
	}
	//print  All | None | Invert | Range
        $content .= '<tr><td colspan="2">'.NL;
        $content .= checkboxLinks("links");
        $content .= "</td></tr>\n";
	
	$content .= "</table>".BN;
	$content .= getUserSelection().NL;
	$content .= '<input type="submit" name="download_parsed" value="' . _("Download") . '" />'.NL;
	
	if(!empty($type_link_array['BitTorrent'])) {
		$content .= '&nbsp;<input type="checkbox" name="force_http" value="TRUE">&nbsp;'._("Force http").BN;
	}
	
	if(!empty($type_link_array['???'])) {
		$content .= BBN._("Domain").': <input type="text" name="domain" size="25" />'.NL;
	}
	$content .= "</form>\n";
	return $content;
}

/*
* dllink_action reroute incoming data
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function dllink_action() {

	$toUser = $_REQUEST["toUser"];
	$force_http = isset($_REQUEST['force_http']);
	$link_string = stripslashes($_REQUEST["link_string"]);
	
	$type_link_array = array();

	if(isset($_REQUEST['download'])) {
	
		$link_array = preg_split('/\n+/', $link_string, -1, PREG_SPLIT_NO_EMPTY);
		
	} elseif(isset($_REQUEST['parse'])) {

		$link_array = link_parser($link_string);
	
		if(!empty($link_array)) {
			return select_links($link_array);
		}

	} elseif(isset($_REQUEST['download_parsed'])) {
	
		$link_array = $_REQUEST['link_array'];
		
		//complete domain
		if(!empty($_REQUEST['domain'])) {
			$link_array = add_link_domain($link_array, $_REQUEST['domain']);
		}
	}

	$type_link_array = link_sorter($link_array, FALSE, $force_http);
	
	//check if links were found
	if(count_leaves($type_link_array) == 0) {
		$_SESSION['message'] .= '<span class="error">' ._("No links found!") . "</span><br />\n";
		return dllink();
	}
	
	if(count_leaves($type_link_array) > 20) {
		$_SESSION['message'] .= '<div class="error">'.sprintf(_("Too much items were selected. (Max. %s)"), 20)."</div>\n";
		return dllink();
	}
	
	download_links($type_link_array, $toUser, $force_http);
	
	return dllink();
}

/*
* add_link_domain add a domain prefix to all links beginning with a slash
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function add_link_domain($link_array, $domain) {

	//add http:// if neccessary of domain
	if(strtolower(substr($domain, 0, 7)) != 'http://') {
		$domain = 'http://'.$domain;
	}
	
	//remove / at the end of domain
	if(substr($domain, -1) == '/') {
		$domain = substr($domain, 0, -1);
	}
	
	//complete uncomplete links
	foreach((array) $link_array as $num => $link) {
		if(substr($link, 0, 1) == "/") {
			$link_array[$num] = $domain.$link;
		} elseif(substr($link, 0, 7) != "http://") {
			$link_array[$num] = $domain.'/'.$link;
		} else {
			$link_array[$num] = $link;
		}
	}
	return $link_array;
}

/*
* link_sorter sort all links of an array by type
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function link_sorter($links, $keep_unknown = FALSE, $force_http = FALSE) {

	$result['BitTorrent'] = array();
	$result['HTTP'] = array();
	$result['Donkey'] = array();
	$result['???'] = array();
	
	foreach((array) $links as $link) {
	
		$link = trim($link);
		if(strlen($link) > 300) { continue; }

		$prefix = strtolower(substr($link, 0, 7));
		$suffix = strtolower(substr($link, -8));
		
		if($prefix == 'ed2k://') {
			$result['Donkey'][] = $link;
		} elseif(!$force_http AND $suffix == '.torrent') {
			$result['BitTorrent'][] = $link;
		} elseif($prefix == 'http://') {
			$result['HTTP'][] = $link;
		} elseif($keep_unknown) {
			$result['???'][] = $link;
		}
	}
	
	array_unique($result['BitTorrent']);
	array_unique($result['HTTP']);
	array_unique($result['???']);
	
	return $result;
}

/*
* link-parser parse out all links inside the string $links
*
* @author    Moritz Warning <mwarning@users.sourceforge.net>
*/
function link_parser($links) {

	//convert alle white spaces to a single white char
	$links = preg_replace('/\s+/',' ' , $links);

	//parse ed2k links
	preg_match_all('/(ed2k:\/\/\|file\|.+?\|\d+?\|[a-f0-9]{32}\|)/i', $links, $ed2k);
	
	//parse href  links
	preg_match_all('/href="((http:\/)?\/?[^"<>]+\/[^"<>]+[^\/])"/i', $links, $href);

	//parse src links
	//preg_match_all('/src="((http:)?\/?\/[^"]+)[\s"\'<>\[\]()]/i', $links." ", $src); //parse src link, they are for images
	
	//parse http links
	preg_match_all('/[^"](http:\/\/[\w.-]+(:\d{2,5})?(\/[\w\.\-\%=&\?\[\]]+)+[^\/])[\s"\'<>\[\]()]/i', " ".$links." ", $http);

	return array_merge($ed2k[0], $href[1], $http[1]);
}

function download_links($type_link_array, $toUser, $force_http) {

	$nrs_alr = array();
	$nrs_queq = array();
	
	foreach($type_link_array as $type => $link_array) {
		if($type == "BitTorrent" AND $force_http) {
			$type = "HTTP";
		}
		
		foreach($link_array as $link) {
			
			$link = urldecode($link); //decode strings like %26 == &
			
			if(strlen($link) > 300) { continue; } //ignore extrem long links
			
			$nr = $_SESSION['interface']->downloadLink($link, $type);

			if(!$nr) {
				$_SESSION['message'] .= '<span class="error">' . _("Unable to match URL.") . "</span>".BN;
				continue;
			} elseif(!$_SESSION['user']->allow_add_Downloads( 1, $_SESSION['interface']->get_size($nr), $toUser)) {
				$_SESSION['interface']->cancelDownloads($nr);
			
			} elseif($_SESSION['user']->downloaded_by_user($nr, $toUser)) {
				$nrs_alr[] = $nr;
			} else {
				$_SESSION['user']->addDownloads($nr, $toUser);
				$nrs_queq[] = $nr;
			}
		}
	}
	
	if(!empty($nrs_queq)) {
		$_SESSION['message'] .= _("Files queued for download:").BN;
		$_SESSION['message'] .= getNameList($nrs_queq);
	}
		
	if(!empty($nrs_alr)) {
		$_SESSION['message'] .= _("Files already queued for download:").BN;
		$_SESSION['message'] .= getNameList($nrs_alr); 
	}
}
?>