<?php

/*
* Show the incoming directory
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function inc() {

	$content = NULL;
	//selection options
	$content .= checkboxJavascript("nr[]");
	$_SESSION['headline'] =  _("Incoming");
	
	//get names of subdirectories and their owners(groups/users)  the user is member of
	$groups = array_keys($_SESSION['user']->groups);
	$owner_array = getAllIncomingDirs();
	foreach($owner_array as $owner => $incoming) {
	
		//convert all dirs to absolute pathes
		if(substr($incoming,0,2) == './') {
			$incoming = $_SESSION['core']->client_incoming.substr($incoming, 2);
		} elseif(substr($incoming,0,1) != '/') {
			$incoming = $_SESSION['core']->client_incoming.$incoming;
		}
		
		if(in_array($owner,$groups) OR ($_SESSION['user']->username == "admin")) {
			$dirs[$incoming][]= $owner;
		}
	}

	//display HDD status
	$content .= "<b>".get_disk_stat($_SESSION['core']->client_incoming)."</b>";
	
	$content .= '<form name="incoming" action="index.php" method="post">'.NL;
	$content .= '<table border="0" cellspacing="0" cellpadding="2">'.NL;

	$columns = 3;
	$content .= '<tr><td colspan="'.$columns.'">'.NL;
        $content .= checkboxLinks("incoming");
        $content .= "</td></tr>\n";
	
	//$dir_size_sum = 0;
	$torrent_exist = FALSE;
	
	$file_id = $_SESSION['file_ident']; //needed to create unique ident numbers, reload would cause delete of many files
	
	$_SESSION['files'] = array();
	foreach($dirs as $dir => $owner_array) {
		$dir_size = 0;
		$i = 0;
		$verz = opendir($dir);
		$show_subdirs = FALSE;
		
		$content .= '<tr><th class="bg_dark" colspan="'.$columns.'">'._("Directory").': "'.getrelpath($dir).'"    '._("Owner").': '.implode(' &amp; ',$owner_array)."</th></tr>\n";
		
		//scan directory
		while ($file = readdir ($verz)) {
			
			//ignore . and ..
			if($file == "." OR $file == "..") { continue; }
		
			//check if file is directory or regular file
			//if($_SESSION['core']->use_php_ff) {
				$is_dir = is_dir($dir.$file);
			//} else {
			//	$is_dir = (trim(exec('stat -c %F "'.$dir.$file.'"')) != "regular file");
			//}
			
			//ignore directories?
			if(!$show_subdirs AND $is_dir) { continue; }
			
			if($i%2 == 0) { $content .=  '<tr class="alt_list" >'.NL;
			} else {	$content .=  '<tr class="list" >'.NL; }
			
			if($is_dir) {
				$content .= "<td>-</td>\n";
				$content .= "<td>".hrName($file)."</td>\n";
				$content .= '<td align="right">-</td>'."\n";
			} else {
				$file_id++;
				$_SESSION['files']['file'.$file_id]['dir'] = $dir.$file;
				$_SESSION['files']['file'.$file_id]['owner'] = $owner_array;
				$content .= '<td><input type="checkbox" name="nr[]" value="file'.$file_id."\" /></td>\n";
			
				$content .= '<td align="left">';
				if($_SESSION['core']->allow_http_download) {
					$content .= '<a href="index.php?CORE_OP=inc_action&http_download=file'.$file_id.'">'.hrName($file)."</a>";
				} else {
					$content .= hrName($file);
				}
				$content .= "</td>\n";
				
				//check for .torrent files
				if(!$torrent_exist AND substr($file, -8) == ".torrent") {
					$torrent_exist = TRUE;
				}
				
				//get file size
				if($_SESSION['core']->use_php_ff) {
					$file_size = filesize($dir.$file);
				} else {
					$file_size = (float) exec('stat -c %s "'.$dir.$file.'"');
				}
				
				$content .= '<td align="right">'.hrSize($file_size)."</td>\n";
			}
			$content .=  "</tr>\n";
			
			$dir_size += $file_size;
			$i++;
		}
		closedir($verz);
		if($i == 0){
			$content .= '<tr class="alt_list" ><td colspan="'.$columns.'" align="center"><b>'._("No Files").'</b></td></tr>'.NL;
		} elseif($i > 1) {
			//print dir size
			$content .= "<tr>\n";
			$content .=  '<td align="right" colspan="'.$columns.'" class=';
			if($i%2 == 0){  $content .=  '"alt_list" >'; }
			else {		$content .=  '"list" >'; }
			$content .= "<strong>".hrSize($dir_size)."</strong></td>\n";
			$content .= "</tr>\n";
		}
		//$dir_size_sum += $dir_size;
	}
	$_SESSION['file_ident'] = $file_id;
	
	//selection options
	$content .= "<tr>\n";
	//$content .= '<td colspan="'.($columns - 1)."\">\n";
	$content .= '<td colspan="'.$columns."\">\n";
        $content .= checkboxLinks("incoming");
        $content .= "</td>\n";
	
	//print dir size sum
	//if($i%2 == 0){  $content .=  '<td align="right" class="alt_list" >'; }
	//else {		$content .=  '<td align="right" class="list" >'; }
	//$content .= "<strong>".hrSize($dir_size_sum)."</strong></td>\n";
	//$content .= "</tr>\n";
	
	$content .= '</table><br />'.NL;

	$content .= '<input type="submit" name="delete_file" value="'._("Delete").'">'.NL;
	if($torrent_exist AND $_SESSION['core']->alive) {
		$content .= '&nbsp;&nbsp;<input type="submit" name="download_torrent" value="'._("Download Torrent").'">'.NL;
		$content .= getUserSelection();
	}
	$content .= '<input type="hidden" name="CORE_OP" value="inc_action" />'.NL;
	$content .= '</form>'.NL;

	//file upload
	if($_SESSION['core']->allow_http_upload) {
		$content .= "<br /><br />\n";
		$content .= '<form enctype="multipart/form-data" action="index.php" method="POST">'.NL;
		$content .= '<input type="hidden" name="MAX_FILE_SIZE" value="'.$_SESSION['core']->max_upload_size.'">'.NL;
		$content .= '<b>'._('Upload File').':</b>&nbsp;<input name="userfile" type="file">'.NL;
		$content .= '<input type="submit" name="http_upload" value="'._("Upload").'">'.NL;
		$content .= '&nbsp;<input type="hidden" name="CORE_OP" value="inc_action" />'.NL;
		$content .= '</form>'.NL;
	}

	return $content;
}

/*
* Handle actions in incoming view
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function inc_action() {

	if(isset($_REQUEST['http_download']) AND $_SESSION['core']->allow_http_download) {
			inc_send_file($_SESSION['files'][$_REQUEST['http_download']]['dir']);
			exit();
		}
	
	if(isset($_REQUEST['http_upload']) AND $_SESSION['core']->allow_http_upload) {
		inc_get_file(getabspath($_SESSION['user']->incoming));
		return inc();
	}
	
	if(empty($_REQUEST['nr'])) {
		$_SESSION['message'] .=  '<div class="error">'._("No items were selected.")."</div><br />\n";
		$_SESSION['files'] = array();
		unset($_POST['delete']);
		return inc();
	}
	
	if(isset($_REQUEST["delete_file"])) {
		return inc_delete_files();
	}

	if($_SESSION['core']->alive) {
	
		if(isset($_REQUEST["download_torrent"])) {
		
			$pathes = array();
			foreach($_REQUEST['nr'] as $nr) {
				$pathes[] = $_SESSION['files'][$nr]['dir'];
			}
			torrent_download($pathes, $_SESSION['user']->username);
		
		}
	}
	
	return inc();
}

/*
* Download a torrent by path to torrent file
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function torrent_download($pathes, $toUser) {
	
	if(count($pathes) > 20) {
		$_SESSION['message'] .= '<div class="error">'.sprintf(_("Too much items were selected. (Max. %s)"), 20)."</div>\n";
		return;
	}
	
	$nrs_queq = array();
	$nrs_alr = array();
	$max_torrent_size = 200*1024; //200KB
	
	foreach($pathes as $path) {
	
		$path = urldecode($path); //decode strings like %26 == &
		
		if(!is_readable($path)) {
			$_SESSION['message'] .= '<div class="error">' . _("File is not readable!") . "</div>".BN;
			continue;
		}
		
		if((substr($path, -8) != ".torrent") OR  (filesize($path) > $max_torrent_size)) {
			$_SESSION['message'] .= '<div class="error">' . _("Item is invalid!") . "</div>".BN;
			continue;
		}
	
		$nr = $_SESSION['interface']->downloadLink($path, "BitTorrent");
		
		if(!$nr) {
			$_SESSION['message'] .= '<div class="error">' . _("Action failed!") . "</div>".BN;
			continue;
		} elseif(!$_SESSION['user']->allow_add_Downloads(1, $_SESSION['interface']->get_size($nr), $toUser)) {
			$_SESSION['interface']->cancelDownloads($nr); // cancel download
			
		} elseif($_SESSION['user']->downloaded_by_user($nr, $toUser)) {
			$nrs_alr[] = $nr;
		} else {
			$_SESSION['user']->addDownloads($nr, $toUser);
			$nrs_queq[] = $nr;
		}
		
	}
	
	if(!empty($nrs_queq)) {
		$_SESSION['message'] .= _("Files queued for download:").BN;
		$_SESSION['message'] .= getNameList($nrs_queq);
	}
	
	if(!empty($nrs_alr)) {
		$_SESSION['message'] .= _("Files already queued for download:").BN;
		$_SESSION['message'] .= getNameList($nrs_alr); 
	}
}

/*
* Move uploaded file to $uploaddir
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function inc_get_file($uploaddir) {
	
	if(!$_SESSION['core']->allow_http_upload) { return; }
	
	if($_SESSION['core']->include_incoming_size) {
		if(!$_SESSION['user']->allow_add_Downloads(0, $_FILES['userfile']['size'], $_SESSION['user']->username)) { //ignore file count in incoming
			return;
		}
	}
	
	switch($_FILES['userfile']['error']) {
		case UPLOAD_ERR_OK:		move_uploaded_file($_FILES['userfile']['tmp_name'], $uploaddir.$_FILES['userfile']['name']);
						chmod($uploaddir.$_FILES['userfile']['name'], 0755);
						$_SESSION['message'] .= _("File was successfully uploaded.").BN;
						break;
		case UPLOAD_ERR_INI_SIZE:	//file size limited by php.ini
		case UPLOAD_ERR_FORM_SIZE: 	$_SESSION['message'] .= '<span class="error">'._("Filesize is too big!")."</span>".BN;
						break; 	//file size limited by $_POST['MAX_FILE_SIZE'] and php.ini
		case UPLOAD_ERR_PARTIAL:	$_SESSION['message'] .= '<span class="error">'._("An error occured while trying to receive the file!")."</span>".BN;
						break;
		case UPLOAD_ERR_NO_FILE:	$_SESSION['message'] .= '<span class="error">'._("No File was uploaded!")."</span>".BN;
						break;
	}
}

/*
* Send a file via http
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function inc_send_file($path) {

	if(!is_readable($path)) { exit("File is not readable!"); }

	//if($_SESSION['core']->use_php_ff) {
		if (!is_file($path) OR connection_status() != 0) { return FALSE; }
	//} else {
	//	if (trim(exec('stat -c %F "'.$path.'"')) != "regular file" OR connection_status() != 0) { return FALSE; }
	//}
	
	$old_time = ini_set("max_execution_time", "20000");
	
	session_write_close();
	
	//send headers
	header("Content-type: application/octet-stream");
	header("Content-Transfer-Encoding: binary");
	
	$user_agent = strtolower($_SERVER["HTTP_USER_AGENT"]);
	if ((is_integer(strpos($user_agent, "msie"))) AND (is_integer(strpos($user_agent, "win")))) {
		header( 'Content-Disposition: filename="'.basename($path).'"' );
	} else {
		header( 'Content-Disposition: attachment; filename="'.basename($path).'"' );
	}
	//header("Content-Disposition: inline; filename=\"".basename($path)."\"");
	if($_SESSION['core']->use_php_ff) {
		header("Content-length: ".(string)(filesize($path)));
	} else {
		header("Content-length: ".trim(exec('stat -c %s "'.$path.'"')));
	}
	header("Expires: ".gmdate("D, d M Y H:i:s", mktime(date("H") + 2, date("i"), date("s"), date("m"), date("d"), date("Y")))." GMT");
	header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", FALSE);
	header("Pragma: no-cache");
	
	if(TRUE) {
		if ($file = fopen($path, 'rb')) {
			do {
			$data = fread($file, 262144);  //=1024*1024 bytes
				if (strlen($data) <= 0) { break; }
				echo $data;
				flush();
			} while (TRUE);
			fclose($file);
		}
	} else { //does work yet, but bufffered only  :(
		$block = 0;
		while($data = exec('dd if='.$path.' ibs=262144 skip='.$block)) {
			echo $data;
			$block++;
			flush();
		}
	}
	ini_set("max_execution_time", $old_time);
}

/*
* delete a file from harddisk
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function inc_delete_files() {

	$nrs = $_POST['nr'];
	
	if(isset($_REQUEST["YESCANCEL"])) {
	
		$deleted_files = array();
		$remained_files = array();
	
		// Cancel the array members
		foreach($nrs as $file) {
			$owners = $_SESSION['files'][$file]['owner'];
			$filePath = $_SESSION['files'][$file]['dir'];
			$allow = TRUE;
			
			if(!$owners) { continue; }//silent reload and manipulation  protection
			
			foreach($owners as $owner) {
				if(!$_SESSION['user']->allow_cancel_Downloads($owner)) {
					$_SESSION['message'] .= _("No permission to cancel files in this directory!").BN;
					$allow = FALSE;
					continue;
				}
			}
			
			if($allow) {
				if(unlink($filePath)) {
					$deleted_files[] = basename($filePath);
				} else {
					$remained_files[] = basename($filePath);
				}
			}
		}
		
		if(!empty($deleted_files)) {
			$_SESSION['message'] .= _("Files deleted:").BN;
			$_SESSION['message'] .= getNameList($deleted_files, FALSE);
		}
		
		if(!empty($remained_files)) {
			$_SESSION['message'] .= _("Cannot delete files:").BN;
			$_SESSION['message'] .= getNameList($remained_files, FALSE); 
		}
		
	} elseif (isset($_REQUEST["NOCANCEL"])) {
		$_SESSION['message'] .= "<p>" . _("Files were NOT deleted.") . "</p>\n";
	} else {
		// Print confirmation page
		$_SESSION['headline'] =  _("Delete Files");
		$content .= '<div align="center">'.NL;
		$content .= '<form name="cancelform" action="index.php" method="post">'.NL;
		$content .= '<input type="hidden" name="CORE_OP" value="inc_delete_files" />'.NL;
		$content .= '<input type="hidden" name="delete" value="1" />'.NL;
		foreach($nrs as $file) {
			$content .= '<input type="hidden" name="nr[]" value="'.$file.'" />'.NL;
		}
		
		$content .= "<b>"._("Are you sure you want to delete these files?")."</b>".BN;
		$content .= "<ul>\n";
		foreach($nrs as $file)
			$content .= "<li>".hrName(basename($_SESSION['files'][$file]['dir']))."</li>\n";
		$content .= "</ul>\n";
		$content .= '<input type="submit" name="YESCANCEL" value="'._("Yes").'" />'.NL;
		$content .= "&nbsp;&nbsp;&nbsp;\n";
		$content .= '<input type="submit" name="NOCANCEL" value="'._("No").'" />'.NL;
		$content .= "</form>\n</div>\n";
		return $content;
	}
	
	$_SESSION['files'] = array();
	unset($_POST['delete']);
	
	return inc();
}

/*
* Displays some disk size properities
* total, free and available - space 
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function get_disk_stat($dir) {

	$avail = diskfreespace($dir);
	$size = disk_total_space($dir);
	
	$used = $size - $avail;
	$used_perc = (1 - $avail/$size)*100;
	
	$content .= '<div class="smalltext">';
	$content .= _("Size").": ".hrsize($size)." | ";
	$content .= _("Used").": ".hrsize($used)." (".round($used_perc, 1)."%) | ";
	$content .= _("Free").": ".hrsize($avail)."<br>";
	$content .= '</div>';
	
	return $content;
}
?>