<?php

/*
* Client searches
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s() {
	$content = NULL;
	
	// Print form to take search keywords
	$_SESSION['headline'] = _("Search");
	$content .= '<form method="post" action="index.php">'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="s_action" />'.NL;

	$content .= '<table border="0">'.NL;
	$content .= "<tr>\n";
	$content .= "<td>"._("Text")."</td>\n";
	$content .= '<td><input type="text" name="keywords" size="50"/></td>'.NL;
	$content .= "</tr>\n";
        
	$content .= "<tr>\n";
	$content .= "<td>" . _("Min. Size (MB)") . "</td>\n";
	$content .= '<td><input type="text" name="minsize" size="10" value=""></td>'.NL;
	$content .= "</tr>\n";
	
	$content .= "<tr>\n";
	$content .= "<td>" . _("Max. Size (MB)") . "</td>\n";
	$content .= '<td><input type="text" name="maxsize" size="10" value=""></td>'.NL;
	$content .= "</tr>\n";
	
	$content .= "</table>\n";
	$content .= '<input type="submit" name="search" value="'._("Search") .'" />'.NL;
	$content .= "</form>\n";
	
	$content .= s_vs();
	
	return $content;
}

/*
* Views Client searches
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_vs()
{
	$content = NULL;
	$content .= '<table cellspacing="0" cellpadding="2" border="0">'.NL;

	$content .= "<tr class=\"bg_dark\">\n";
	$content .= "<th>"._("No.")."</th>\n";
	$content .= "<th>"._("Search Terms")."</th>\n";
	$content .= "<th>"._("Found")."</th>\n";
	$content .= "<th>"._("View")."</th>\n";
	$content .= "<th>"._("Forget")."</th>\n";
	$content .= "</tr>\n";
	$c = 0;
	$searches = $_SESSION['interface']->getAllSearches();
	foreach($searches as $search) {
		if($_SESSION['user']->allow_show_Search($search->searchnum)) {
			if($c%2 == 0) { $content .= '<tr class="list">'.NL;     }
			else          { $content .= '<tr class="alt_list">'.NL; }
			
			$content .= '<td align="center">'.$search->searchnum."</td>\n"; 
			$content .= '<td align="left">'.$search->terms."</td>\n"; 
			$content .= '<td align="center">'.$search->found."</td>\n"; 
			$content .= '<td>[ <a href="index.php?CORE_OP=s_action&results=1&searchnum='.$search->searchnum.'">' . _("View Results") . "</a> ]</td>\n";
			$content .= '<td>[ <a href="index.php?CORE_OP=s_action&forget=1&searchnum='.$search->searchnum.'">' . _("Forget Search") . "</a> ]</td>\n";
			$content .= "</tr>\n";
			$c++;
		}
	}
	$content .= "</table>\n";
	if($c == 0) {
		$content = '<div align="center">' . _("No searches in the System.") . "</div>\n"; //replace all $content by this
	}
	return $content;
}

/*
* handle search actions
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_action() {

	// start search
	if(isset($_REQUEST["search"])) {
		//create search item
		$search = array();
		$search['keywords'] = $_REQUEST["keywords"];
		if($minsize = (int) $_REQUEST["minsize"]) {
			$search['minsize'] = $minsize;
		}
		if($maxsize = (int) $_REQUEST["maxsize"]) {
			$search['maxsize'] = $maxsize;
		}
		if($network = $_REQUEST["network"]) {
			$search['network'] = $network;
		}
		
		$searchnum = $_SESSION['interface']->addSearch($search);
		$_SESSION['user']->search_add($searchnum);
		return s();
	}

	//forget search
	if(isset($_REQUEST["forget"])) {
		s_forget($_REQUEST["searchnum"]);
		return s();
	}
	
	//view search results
	if(isset($_REQUEST["results"])) {
		return s_vr($_REQUEST["searchnum"]);
	}
	
	//download search result
	if(isset($_REQUEST["download"])) {
		s_d($_REQUEST['toUser'], $_REQUEST["searchnum"], $_REQUEST["nr"]);
		return s_vr($_REQUEST["searchnum"]);
	}
	
	return s();
}

/*
* Displays search results
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_vr($searchnum)
{
	if(!isset($searchnum)) {
		$_SESSION['messages'] .= '<div class="error">'._("No items were selected.")."</div>\n";
		return s();
	}
	
	$_SESSION['headline'].= _("Search Results");

	$headers = array();
	$headers["action"]          = "";
	$headers["name"]            = _("Name");
	$headers["size"]            = _("Size");
	$headers["availability"]    = _("Availability");
	$columns = count($headers);
	
	$content = NULL;
	$content .= '<form name="sform" method="post" action="index.php">'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="s_action" />'.NL;
	$content .= '<input type="hidden" name="results" value="1" />'.NL; //default action
	$content .= _("Other Searches") . ":\n";
	
	//select other searches
	if($_SESSION['core']->use_javascript) {
		$content .= '<select name="searchnum" onchange="javascript:document.sform.submit()">'.NL;
	} else {
		$content .= '<select name="searchnum">'.NL;
	}
	
	//print search select form
	$searches = $_SESSION['interface']->getAllSearches();
	foreach($searches as $search) {
		//filter own searches
		if($_SESSION['user']->allow_show_Search($search->searchnum)) {
			//select box entries
			$content .= '<option value="'.$search->searchnum.'"';
			if ($search->searchnum == $searchnum) {
			    $content .= " selected";
			}
			$content .= ">$search->terms</option>\n";
		}
	}
	$content .= "</select>\n";
	if(!$_SESSION['core']->use_javascript) {
		$content .= '<input type="submit" value="' . _("Go") . '" />'.NL;
	}
	$content .= '<input type="submit" name="forget" value="' . _("Forget Search") . '" />'.NL;
	$content .= "</form>".BN;
	
	$c = 0;
	$content .= checkboxJavascript("nr[]");
	$content .= '<form name="dform" action="index.php" method="post">'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="s_action" />'.NL;
	$content .= '<input type="hidden" name="searchnum" value="'.$searchnum.'" />'.NL;
	$content .= '<table cellspacing="0" cellpadding="2" border="0">'.NL;

	$content .= '<tr><td colspan="'.$columns.'">'.NL;
	$content .=  checkboxLinks("dform");
	$content .= '<input type="submit" name="download" value="'._("Download Selected Items").'" />&nbsp;&nbsp;'.NL;
	
	//select target owner
	$content .= getUserSelection();
	$content .= "</td></tr>\n";
	
	//print header
	$content .= getTableHeader($headers, 's_action&results=1&searchnum='.$searchnum);

	$searchResults = $_SESSION['interface']->getSearchResults($searchnum);
	$results = sort_objects($searchResults, "availability", "DESC", "s_vr");
	
	unset($_SESSION['snrs_names']);
	
	if(sizeof($results) != 0) {
		
		foreach($results as $resultlevel) {
		foreach($resultlevel as $result) {
			if($c%2 == 0) { $content .= '<tr class="list">'.NL;     }
			else          { $content .= '<tr class="alt_list">'.NL; }
	
			$_SESSION['snrs_names'][$result->resultnum] = $result->name;
			
			$content .= "<td>\n";
			$content .= '<input type="checkbox" name="nr[]" value="'.$result->resultnum.'" />'.NL;
			$content .= '<td align="left">'.hrName($result->name, 120)."</td>\n";
			$content .= '<td align="right" nowrap="nowrap">' . hrSize($result->size) . "</td>\n"; 
			$content .= '<td align="center">'.$result->availability."</td>\n"; 
			$content .= "</tr>\n";
			$c++;
		}
		}
	} else {
		$content .= '<tr class="alt_list"><td colspan="'.$columns.'" align="center"><b>'.sprintf(_("No %s."),_("Results")).'</b></td></tr>'.NL; 
	}
	$content .= '<tr><td colspan="'.$columns.'">'.NL;
	$content .=  checkboxLinks("dform");
	$content .= '<input type="submit" name="download" value="' . _("Download Selected Items") . "\" />&nbsp;\n";
	$content .= "</td></tr>\n";
	$content .= "</table>\n";
	$content .= "</form>\n";
	
	return $content;

}

/**
* Forces a download
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_force()
{
	$_SESSION['interface']->forceDownload();
	$_SESSION['message'] .= _("Download Forced");
	return s_vr();
}

/**
* Forgets search results
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_forget($searchnum)
{
	if(!isset($searchnum)) {
		$_SESSION['message'] .= '<div class="error">'._("No items were selected.")."</div>";
	} elseif(!$_SESSION['user']->allow_show_Search($searchnum)){
		$_SESSION['message'] .= '<div class="error">'._("Access denied!")."</div>";
	} else {
		$_SESSION['interface']->delSearches($searchnum);
		$_SESSION['user']->search_del($searchnum);
		$_SESSION['message'] .= _("Search forgotten.").BN;
	}
}

/**
* Downloads search result
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function s_d($toUser, $sid, $snrs) {

	if(!isset($toUser) OR !isset($sid) OR !isset($snrs)) {
		$_SESSION['message'] .= '<div class="error">'._("No items were selected.")."</div>\n";
		return;
	}
	
	/*
	* too much started downloads at once may result in undefiened behaviour when the user start pushing buttons
	* because the response take so long, if you are not paranoid you may want to  coment it out.
	*/
	if(count($snrs) > 20) {
		$_SESSION['message'] .= '<div class="error">'.sprintf(_("Too much items were selected. (Max. %s)"), 20)."</div>\n";
		return;
	}
	
	if(!$_SESSION['user']->allow_show_Search($sid)) {
		$_SESSION['message'] .= '<div class="error">'._("Access denied!")."</div>\n";
		return;
	}
	
	$size = 0;
	$started = array();
	$already = array();
	$add = array();
	$started = $_SESSION['interface']->downloadSearch($sid, $snrs); //$started is an array of nr of started downloads, but not realy trustable

	//get unrecognized file nrs that were already started or failed
	if(count($started) != count($snrs)) {
		//get selected names
		foreach($snrs as $snr) {
			$names[] = $_SESSION['snrs_names'][$snr];
		}

		$names_nrs = $_SESSION['interface']->get_nr_by_name($names);
		
		foreach($names_nrs as $name => $nr) {
			if(in_array($nr, $started)) { continue; }
			if($_SESSION['user']->downloaded_by_user($nr, $toUser)) {
				$already[] = $nr;
			} else {
				$add[] = $nr;
				$size += $_SESSION['interface']->get_size($nr);
			}
		}
	}
	$add_new = array_merge($started, $add);

	//check if every selected search result can downloaded/associated with the user
	if((count($add_new) + count($already)) != count($snrs)) {
		$_SESSION['message'] .= _("Not all downloads could be started.").BN;
	}
	
	//sum size
	foreach($add_new as $nr) {
		$size += $_SESSION['interface']->get_size($nr);
	}
	
	//check for permissions
	if(!$_SESSION['user']->allow_add_Downloads(count($add_new), $size, $toUser)) {
		$_SESSION['interface']->cancelDownloads($started);
		return s_vr();
	}

	if(count($add_new) > 0) {
		$_SESSION['user']->addDownloads($add_new, $toUser);
		$_SESSION['message'] .= _("Downloads started:").NL;
		$_SESSION['message'] .= getNameList($add_new);
	}
	
	if(count($already) > 0) {
		$_SESSION['message'] .= _("Files already downloaded:").NL;
		$_SESSION['message'] .= getNameList($already);
	}
}
?>
