<?php

/*
* Displays shared directories
*
* @author Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function shares()
{
	$content = NULL;
 
	$_SESSION["headline"] = _("Shares");
	$content .= '<table cellspacing="0" cellpadding="2" border="0">'.NL;
	$content .= "<tr class=\"bg_dark\">\n";
	$content .= "<th>" . _("Directory") . "</th>\n";
	$content .= "<th>" . _("Priority") . "</th>\n";
	$content .= "<th>" . _("Size") . "</th>\n";
	$content .= "<th>&nbsp;</th>\n";
	$content .= "</tr>\n";

	if (!isset($_SESSION["core"]->client_basedir)) {
		return '<div class="error">'._("Not Available.")."<div>\n";
	}
	
	$shares = $_SESSION['interface']->getShares();
	
	$c = 0;
	foreach($shares as $shared) {
		if($c%2 == 0) { $content .= '<tr class="list">'.NL; }
		else { $content .= '<tr class="alt_list">'.NL; }
		$abs_dir = $_SESSION['core']->client_basedir.$shared->dir;
		$content .= '<td align="center">'.$shared->dir."</td>";
		$content .= '<td align="center">'.$shared->priority."</td>";
		$content .= '<td align="right">'.hrSize(get_dir_size($abs_dir, FALSE))."</td>";
		$content .= '<td align="center"><a href="index.php?CORE_OP=shares_unshare&directory='.$shared->dir.'">' . _("Unshare") . "</a></td>";
		$content .= "</tr>\n";
		$c++;
	}
	$content .= '</table>';
	
	$content .= '<form method="post" action="index.php">'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="shares_reshare" />'.NL;
	$content .= '<input type="submit" value="' . _("Rescan Uploads") . "\" />\n";
	$content .= "</form>\n";

	$content .= '<form method="post" action="index.php">'.NL;
	$content .= '<input type="text" size="12" name="directory" value="" />'.NL;
	$content .= '<input type="text" size="4" name="priority" value="0" />'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="shares_share" />'.NL;
	$content .= '<input type="submit" value="' . _("Share") . "\" />\n";
	$content .= "</form>\n";

	return $content;
}

/*
* Adds directories to be shared
*
* @author  Moritz Warning <mwarning@users.sourceforge.net>
*/
function shares_share()
{
	if(isset($_REQUEST["directory"]) AND isset($_REQUEST["directory"]) AND $_SESSION['interface']->share($_REQUEST["priority"], $_REQUEST["directory"])) {
		$_SESSION["message"] .= '<div class="status">' . _("Directory Shared") . "</div>\n";
	} else {
		$_SESSION["message"] .= '<div class="status">' . _("Action failed!") . "</div>\n";
	}
	
	return shares();
}

/*
* Checks files in shared_directories and updates internal listing
*
* @author  Moritz Warning <mwarning@users.sourceforge.net>
*/
function shares_reshare()
{
	// MLDonkey now automically updates its list periodically,
	// so this command is seldom useful
	if($_SESSION['interface']->reshare()) {
		$_SESSION["message"] .= '<div class="status">' . _("Rescan Complete") . "</div>\n";
	} else {
		$_SESSION["message"] .= '<div class="error">' . _("Action failed!") . "</div>\n";
	}
	
	return shares();
}

/*
* Removes directories from list of shared directories
*
* @author  Moritz Warning <mwarning@users.sourceforge.net>
* 
*/
function shares_unshare()
{
	if(isset($_REQUEST["directory"]) AND $_SESSION['interface']->unshare($_REQUEST["directory"])) {
		$_SESSION["message"] .= '<div class="status">' . _("Directory Unshared.") . "</div>\n";
	} else {
		$_SESSION["message"] .= '<div class="error">' . _("Action failed!") . "</div>\n";
	}
	return shares();
}
?>
