<?php

/**
* Show user panel schema with move arrows 
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getSortableUserPanel($username, $get_vars, $titlebar) {

	$i = 0;
	$titlebar;
	$count = count($titlebar);
	$perrow = ceil($count/(ceil($count/8)));
	foreach($titlebar as $key) {
		$i++;
		$content .= "<nobr>\n";
		$content .= '<a href="index.php?'.$get_vars.'&moveItem='.$key.'&move=-1">&larr;</a> '."\n";
		
		$value = $_SESSION['core']->clientUpPanels[$key];
		if(!isset($value)) {
			$value = $_SESSION['core']->clientDownPanels[$key];
		}
		$content .= _($value)."\n";
		
		$content .= ' <a href="index.php?'.$get_vars.'&moveItem='.$key.'&move=1">&rarr;</a>'."\n";
		$content .= "</nobr>";
		if($i < $count) { $content .= " | "; }
		if($i%$perrow == 0 ) { $content .= "<br \>"; }
	}
	$content .= "\n";
	return $content;
}

/**
* Show table to enable/disable  panel items
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getSelectablePanelItems($username, $availableItems, $selectedItems) {

	$i = 0;
	$content .= '<table border="0">'."\n";
	$content .= "<tr>\n";
	foreach($availableItems as $key => $value)
	{	
		if(!isset($value)) { continue; }
		$i++;
		$content .= '<td><input type="checkbox" name="newSettings[titlebar][]" value="'.$key.'"';
		if(in_array($key, $selectedItems)) {
			$content .= " checked=\"checked\" />";
		} else {
			$content .= " />";
		}
		$content .= "</td>";
		$content .= "<td>"._($value)."</td>\n";
		if($i%4 == 0 ){ $content .= "</tr><tr>\n"; }
	}
	$content .= "</tr>\n</table>\n";
	return $content;
}

/*
* apply_order apply the order of $old to $new
* 
* $new = array("A", "B", "C", "D", "E"),  $old= array( "B", "A", "D", "G")
* =>  array( "B", "A", "D", "C", "E")
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function apply_order($old, $new) {

	$out = array();
	$apply = array();
	
	//add old item that exist
	foreach($old as $item) {
		if(in_array($item, $new)) {
			$out[] = $item;
		}
	}
	
	$apply = array_diff($new, $old);
	
	return array_merge($out, $apply);
}

/**
*  array_move_elem moves a single element of an array 
*  $shift elements forward/backward
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function array_move_elem($array, $offset, $range, $shift) {

	//cut
	$elem = array_splice($array, $offset, $range);

	$len = count($array);
	$insert_pos = ($offset + $shift)%($len + 1);
	if($insert_pos < 0) { $insert_pos += $len + 1; }
	
	//insert
	array_splice($array, $insert_pos , 0, $elem);
	
	return $array;
}


/**
*  get a select list
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getSelectList($elems, $selected, $name) {

	$content .= '<select name="'.$name.'" style="width: 100%;">'."\n"; //need to replacestyle by class
	foreach($elems as $elem) {
		if ($elem == $selected) {
			$content .= '<option value="'.$elem.'" selected>'.$elem."</option>\n";
		} else {
			$content .= '<option value="'.$elem.'">'.$elem."</option>\n";
		}
	}
	$content .= "</select>";
	return $content;
}

/**
* get list of names
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getNameList($items, $get_name_by_nr = TRUE) {
	$content = "<ul>\n";
	foreach($items as $item) {
		if($get_name_by_nr) {
			$item = $_SESSION['interface']->get_name($item);
		}
		$content .= '<li>'.hrName($item)."</li>\n";
	}
	$content .= "</ul>\n";
	return $content;
}

/*
* sort an array by  $default_sortkey or by  $_REQUEST["SORTKEY"] and $default_sortorder or $_REQUEST["SORTORDER"]
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function sort_objects($object_array, $default_sortkey, $default_sortorder, $id) {

	$object_array = (array) $object_array;

	//set sortkey
	if(isset($_REQUEST["SORTKEY"])) {
		$sortkey = $_REQUEST["SORTKEY"];
	} elseif(isset($_SESSION[$id.'_sortkey'])) {
		$sortkey = $_SESSION[$id.'_sortkey'];
	} else {
		$sortkey = $default_sortkey;
	}
	
	//set sortorder
	if(isset($_REQUEST["SORTORDER"])) {
		$sortorder = $_REQUEST["SORTORDER"];
	} elseif(isset($_SESSION[$id.'_sortorder'])) {
		$sortorder = $_SESSION[$id.'_sortorder'];
	} else {
		$sortorder = $default_sortorder;
	}

	//index objects by sortkey
	$objects = array();
	$firstval = current($object_array);
	//if(is_string($firstval->{$sortkey})) {
	foreach($object_array as $object) {
		$objects[strtolower($object->{$sortkey})][] = $object;
	}
	//} else {
	//	foreach($object_array as $object) {
	//		$objects[(String)$object->{$sortkey}][] = $object;
	//		echo $object->{$sortkey}.BN;
	//	}
	//}
	
	//sort by key in sortorder
	if($sortorder == "ASC") {
		ksort($objects);
	} elseif ($sortorder == "DESC") {
		krsort($objects);
	}
	
	$_SESSION[$id.'_sortkey'] = $sortkey;
	$_SESSION[$id.'_sortorder'] = $sortorder;
	reset($objects);
	return $objects;
}

/*
* get a select form of all target users who can receive downloads
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getUserSelection() {
	$content = NULL;
	$ok = FALSE;
	$groups = array();
        $content .= '<select name="toUser" size="1">'."\n";
	
	if($_SESSION['user']->username == 'admin') { // admin can select all Users and Groups
		$groups = array_merge($_SESSION['user']->getAllUsers(), $_SESSION['user']->getAllGroups());
	} else { // normal user  can only select groups he is member of
		$groups = array_keys($_SESSION['user']->groups);
	}
	
	foreach($groups as $group) {
		if($_SESSION['user']->allow_add_Downloads_by_right($group)) {
			$content .= "   <option value=\"$group\">$group</option>\n";
			$ok = TRUE;
		}
        }
	/*if($_SESSION['user']->username == "admin") {
		$content .= "   <option value=\"-\">-</option>\n";
		$ok = TRUE;
	}*/
	$content .= "</select>\n";
	
	if($ok) {
		return $content;
	} else {
		return "";
	}
}

/*
* get a select form of predivined priorities
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getPrioritySelection() {

	$content = '<select name="priority" size="1">'."\n";
        foreach($_SESSION['core']->priorities as $key => $value) {
            $content .= '   <option value="'.$key.'">'._($value)."</option>\n";
        }
        $content .= "</select>\n";
	return $content;
}
/**
*  Return names of  subdirectories of $dir
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/	
	function getDirs($dir) {
		$dirs = array();
		$base_dir = opendir($_SESSION['core']->gmui_dir.$dir);
		while ($subdir = readdir($base_dir)) {
			if(is_dir($_SESSION['core']->gmui_dir.$dir.$subdir) AND $subdir != "." AND $subdir != "..") {
				$dirs[] = $subdir;
			}
		}
		closedir($base_dir);
		return $dirs;
	}

/*
* getAllIncomingDirs parse all download numbers out of the MLDonkey an return them as an owner => dir
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getAllIncomingDirs() //used in ./lib/SharedFunc.php and ./lib/Incoming.php
{
	$owner_incoming = array();
	$MLDincoming = $_SESSION['core']->client_incoming;

	$result1 = $_SESSION['db']->query(  "SELECT groups, incoming FROM group_settings");
	$result2 = $_SESSION['db']->query(  "SELECT user, incoming FROM user_settings");
	
	//collect group => incoming directory
	while($row = $_SESSION['db']->fetch_array($result1)) {
		$owner_incoming[$row['groups']] = preg_replace('/\.\//','',$row['incoming']);
	}
	
	//collect user => incoming directory
	while($row = $_SESSION['db']->fetch_array($result2)) {
		$owner_incoming[$row['user']] = preg_replace('/\.\//','',$row['incoming']);
	}
	
	return $owner_incoming;
}

/**
* Displays Javascript to do checkbox manipulations
*
* @author   CJ Kucera <zuul@NOSPAM.apocalyptech.com>
*/
function checkboxJavascript($name)
{
    $content = "";
    if ($_SESSION["core"]->use_javascript) {
        $content .= "<script language=\"Javascript\">\n";
        $content .= "//<!--\n";
        $content .= "// Based heavily on Javascript from sharereactor.com\n";
        $content .= "function allBoxes(id, value) {\n";
        $content .= "  var i=0;\n";
        $content .= "  while (id.elements[i]) {\n";
        $content .= "    if (id.elements[i].name == '".$name."') {\n";
        $content .= "      id.elements[i].checked=value;\n";
        $content .= "    }\n";
        $content .= "    i++;\n";
        $content .= "  }\n";
        $content .= "}\n";
        $content .= "function invertBoxes(id) {\n";
        $content .= "  var i=0;\n";
        $content .= "  while (id.elements[i]) {\n";
        $content .= "    if (id.elements[i].name == '".$name."') {\n";
        $content .= "      if (id.elements[i].checked == 1) {\n";
        $content .= "        id.elements[i].checked=0;\n";
        $content .= "      } else {\n";
        $content .= "        id.elements[i].checked=1;\n";
        $content .= "      }\n";
        $content .= "    }\n";
        $content .= "    i++;\n";
        $content .= "  }\n";
        $content .= "}\n";
        $content .= "function rangeBoxes(id) {\n";
        $content .= "  var i=0;\n";
        $content .= "  var foundchecked=0;\n";
        $content .= "  while (id.elements[i]) {\n";
        $content .= "    if (id.elements[i].name == '".$name."') {\n";
        $content .= "      if (id.elements[i].checked == 1) {\n";
        $content .= "        if (foundchecked == 1) {\n";
        $content .= "          return;\n";
        $content .= "        }\n";
        $content .= "        foundchecked = 1;\n";
        $content .= "      } else if (foundchecked == 1) {\n";
        $content .= "        id.elements[i].checked = 1;\n";
        $content .= "      }\n";
        $content .= "    }\n";
        $content .= "    i++;\n";
        $content .= "  }\n";
        $content .= "}\n";
        $content .= "//-->\n";
        $content .= "</script>\n";
    }
    return $content;
}

/**
* Displays links to do checkbox manipulations
*
* @author   CJ Kucera <zuul@NOSPAM.apocalyptech.com>
*/
function checkboxLinks($formname)
{
    $content = "";
    if ($_SESSION["core"]->use_javascript) {
        $content .= "<a href=\"javascript:allBoxes(document.forms.$formname, 1);\">" . _("All") . "</a> |\n";
        $content .= "<a href=\"javascript:allBoxes(document.forms.$formname, 0);\">" . _("None (select)") . "</a> |\n";
        $content .= "<a href=\"javascript:invertBoxes(document.forms.$formname);\">" . _("Invert") . "</a> |\n";
        $content .= "<a href=\"javascript:rangeBoxes(document.forms.$formname);\">" . _("Range") . "</a>\n";
    }
    return $content;
}

/**
* Make a commit - generated script will be executed by the mldonkey and make a hard-links/copy to every directory of every user
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
//need to add function to cancel downloads if they where not sheduled _before_ the script wait for them
function updateCommitScript()
{
	if(!$_SESSION['core']->make_commit_script) { return; }
	
	//do not try to update when not all information are accessible
	if(!$_SESSION['interface']->alive()) { return; }
	
	$nr_owner = array();
	$mldBaseDir = $_SESSION['core']->client_basedir;
	$MLDincoming = $_SESSION['core']->client_incoming;
	
	$result = $_SESSION['db']->query("SELECT owner, nr FROM downloads");
	while ($row = $_SESSION['db']->fetch_array($result))
	{
		$nr_owner[$row['nr']][] = $row['owner'];
	}
	$owner_incoming = getAllIncomingDirs(); // $owner =>"own  incoming directory"

	$script_name = "commit.sh";

	$file = fopen($mldBaseDir.$script_name, 'w');
	if(!$file) {
		$_SESSION['message'] .= "Cannot write file ".$mldBaseDir.$script_name."!".BN."Please set write permissions or set make_commit_script = FALSE in ./conf/config.php!".BN;
		return;
	}
	
	//make commit.sh executeable
	if(file_exists($mldBaseDir.$script_name) AND !is_executable($mldBaseDir.$script_name))
	{
		shell_exec('chmod a+x '.$mldBaseDir.$script_name);
	}
	
	flock($file,2);
	//hash = $1, size_byte = $2, name = $3
$content =
'#!/bin/bash
echo "New file: hash "$1" size "$2" name "$3""

#get hash value, last 32 (+1 NL?) chars
match=`echo $1 | tail -c 33`

echo "match "$match""

rounds=60

if [ `echo $1 | head -c 2` != "BT" ]
then
#for non torrent downloads
	for ((  i = 1 ; i <= $rounds;  i++  ))
	do
		if [ `find '.$MLDincoming.' -maxdepth 1 -cmin 1 -size ${2}c -type f  | wc -l` -eq 0 ]
		then
			sleep 3
			echo "Wait 3 seconds"
			if test $i -eq $rounds
			then
				echo "No new file found."
				exit 1
			fi
		fi
	done
	result=`find '.$MLDincoming.' -maxdepth 1 -cmin 1 -size ${2}c -type f | head -n1`
else
#for torrent downloads, risky, but works in most cases
	for ((  i = 1 ; i <= $rounds;  i++  ))
	do
		if [ `find '.$MLDincoming.' -mindepth 1 -maxdepth 0 -cmin 1 | wc -l` -eq 0 ]
		then
			sleep 3
			echo "Wait 3 seconds"
			if test $i -eq $rounds
			then
				echo "No new file found."
				exit 1
			fi
		fi
	done
	result=`find '.$MLDincoming.' -mindepth 1 -maxdepth 0 -cmin 1 | head -n1`
fi

#wait some time so directories from bittorent can be moved, just for sure
sleep 5

#prevent from some simple hacks
if [ `echo $1 | head -c 1` == "*" ]
then
	exit 1
fi
if [ `echo $1 | head -c 1` == "." ]

then
	exit 1
fi

rem=1
echo "Found file: "$result""
';
	//$content .= 'result=`find '.$MLDincoming.' -maxdepth 1 -cmin 1 -size ${2}c -type f`'."\n";
	$content .= 'case $match in'."\n";
	
	foreach($nr_owner as $nr => $owners)
	{
		$rem = TRUE; //remove file from incoming when hard links are set
		$temp = array();
		
		$ident = $_SESSION['interface']->get_hash($nr);
		
		//skip empty identifiers, empty values cause script abortion
		if($ident == "") { continue; }
	
		$content .= $ident.")\n";
		foreach($owners as $owner)
		{
			if(!in_array($owner_incoming[$owner],$temp)) //prevent double entries
			{
				$temp[] = $owner_incoming[$owner];
				if(($owner_incoming[$owner] == $MLDincoming) OR ($MLDincoming.$owner_incoming[$owner] == $MLDincoming))
				{
					$content .= "	rem=0\n"; continue;
				}
				
				//set target path
				if(substr($owner_incoming[$owner], 0, 1) == "/") {
					$target_path = $owner_incoming[$owner];
				} else {
					$target_path = $MLDincoming.$owner_incoming[$owner];
				}
				
				//check if using copy or use hard links
				if($_SESSION['core']->use_hard_links) {
					$content .= '	ln "$result" '.$target_path.' || cp -r "$result" '.$target_path." || rem=0\n";
				} else {
					$content .= '	cp -r "$result" '.$target_path." || rem=0\n";
				}
				
				//apply chmod command after file is moved
				if($_SESSION['core']->chmod) {
					$content .= '	temp='.$target_path.'`basename "$result"`'."\n";
					$content .= '	chmod -R '.$chmod.' $temp'."\n";
				}
			}
		}
		$content .= "	;;\n";
	}
	$content .= "*)\n";
	$content .= "	echo \"identifier not scheduled\"\n";
	$content .= "	rem=0\n";
	$content .= "	exit 1\n";
	$content .= "	;;\n";
	$content .= "esac\n\n";
	
	$content .= "if [ \$rem -eq 1 ]\n";
	$content .= "then\n";
	$content .= '	rm -r "$result"'."\n"; //very risky in case the files name is '.' or  '*'  :(
	$content .= "	echo 'File moved.'\n";
	$content .= "	echo 'File in ".$MLDincoming." deleted.'\n";
	$content .= "else\n";
	$content .= "	echo 'File not moved.'\n";
	$content .= "fi\n";
	
	fwrite($file,$content);
	flock($file,3);
	fclose($file);
}

/*
* count all leaves of array in array contructs
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function count_leaves($array) {
	$c = 0;
	foreach($array as $elem) {
		if(is_array($elem)) {
			$c += count_leaves($elem);
		} else {
			$c++;
		}
	}
	return $c;
}

/*
* returns sum of files sizes in a directory in bytes
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function get_dir_size($dir, $recursiv = FALSE) {
	
	if(!file_exists($dir) OR !is_readable($dir)) { return "?"; }
	
	$dir_handle = opendir($dir);
	$sum = 0;
	while ($file = readdir($dir_handle)) {
		if(($file != ".") AND ($file != "..")) {
			
			if($_SESSION['core']->use_php_ff) {
				if(!is_dir($dir.$file)) {
					$sum += filesize($dir.$file);
				} elseif($recursiv) {
					$sum += get_dir_size($dir.$file.DIRECTORY_SEPARATOR, TRUE);
				}
			} else {
				if(trim(shell_exec('stat -c %F "'.$dir.$file.'"')) != "directory") {
					$sum += (float) shell_exec('stat -c %s "'.$dir.$file.'"');
				} elseif($recursiv) {
					$sum += get_dir_size($dir.$file.DIRECTORY_SEPARATOR, TRUE);
				}
			}
		}
	}
	return $sum;
}

/*
* get relative directory, FALSE if directory does not exist
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getrelpath($path) {

	if(!preg_match("/^(\/|\.\/)([\w ]+\/?)*$/", $path)) { return FALSE; }
	
	$basedir = $_SESSION['core']->client_incoming;
	$len = strlen($basedir);
	
	//add missing separator at path end
	if(substr($path, -1) != DIRECTORY_SEPARATOR) {
		$path .= DIRECTORY_SEPARATOR;
	}
	
	//convert to relative dir
	if(substr($path, 0, 1) == DIRECTORY_SEPARATOR) {
	
		if(!is_dir($path)) { return FALSE; }
		if($basedir == substr($path, 0, $len)) {
			return ".".DIRECTORY_SEPARATOR.substr($path, $len);
		} else {
			return $path;
		}
	} elseif (substr($path, 0, 2) == ".".DIRECTORY_SEPARATOR) {
		if(!is_dir($basedir.substr($path, 2))) { return FALSE; }
		return $path;
	} else {
		return FALSE;
	}
}

/*
* get absolute directory, FALSE if directory does not exist
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function getabspath($path) {
	$basedir = $_SESSION['core']->client_incoming;

	if(empty($path)) { return $basedir; }

	//add missing '/' to end
	if(substr($path, -1) != DIRECTORY_SEPARATOR) {
		$path .= DIRECTORY_SEPARATOR;
	}
	
	//convert to absolute dir
	if(substr($path, 0, 1) == DIRECTORY_SEPARATOR) {
	} elseif(substr($path, 0, 2) == '.'.DIRECTORY_SEPARATOR) {
		$path = $basedir.substr($path, 2);
	} else {
		$path = $basedir.$path;
	}
	
	//check if dir exists
	if(is_dir($path)) {
		return $path;
	} else {
		return FALSE;
	}
}
?>
