<?php
/*
* default theme template functions
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author   Moritz Warning <mwarning@users.sourceforge.net>
*/

function getSite() {

	$theme_path = $_SESSION['core']->subDirs["theme_dir"] . $_SESSION['user']->theme;
	$body = $_SESSION['core']->getBody(); //need be executed before get messages
	
	$content = '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">'."\n";
	$content .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
	$content .= "<head>\n";
        $content .= "<title>".$_SESSION['title'] ."</title>\n";
	$content .= '<link rel="stylesheet" href="'.$theme_path .'/style.css" type="text/css" />'."\n";
        $content .= "</head>\n";
        $content .= "<body>\n";
	
	$content .= "<div align=\"center\">\n";
	
	$content .= "<br />\n";
        $content .= getHeader();
	$content .= "<br />\n";
	
	$content .= '<table width="98%" border="0">'."\n";
	$content .= '<tr align="center" valign="top">'."\n";
	$content .= '<td align="left" width="33%"><nobr>'.$_SESSION['message']."</nobr></td>\n";
	$content .= '<td align="center" width="33%"><h3>'.$_SESSION['headline']."</h3></td>\n";
	$content .= '<td align="right" width="33%">'.getPageRefresh()."</td>\n";
	$content .= "</tr>\n";
	$content .= "</table>\n";
	
	$content .= "<br />\n";
	$content .= $body;
	$content .= "<br />\n";
	
	$content .= "</div>\n";
	
	
	$content .= '<div class="smalltext" valign="bottom">'."\n";
	$content .= "<hr size=\"1\" noshade />\n";
	$content .= getVersionString();
	$content .= "</div>\n";
	
	$content .= "</body>\n";
	$content .= "</html>";
        return $content;
}

function getHeader() {

	$menu = $_SESSION["core"]->getMenu();
	$items = count($menu);
	$maxitems = 9;
	$perrow = ceil($items/(ceil($items/$maxitems)));
	$partition = array_pad(array(), ceil($items/$perrow), $perrow);

	$offset = 0 ;
	$first = TRUE;
	
	for($i = 0; $i < count($partition); $i++)
	{
		$row = array_slice($menu, $offset, $partition[$i]);
		$offset += $partition[$i];
		
		if($first) {
			$content .= '<table class="panel" align="center" rules="all" style="border-top-style: solid; border-top-width: 1px; ">'."\n<tr>\n";
			$first = FALSE;
		} else {
			$content .= '<table class="panel" align="center" rules="all">'."\n<tr>\n";
		}
		
		foreach($row as $link) {
			if ($link->active) 	{ $content .= '<td bgcolor="#cfcee0">'; }
			else 			{ $content .= '<td>'; }
			$content .= '<a href="'.$link->href.'">' . $link->text . '</a></td>'."\n";
		}
		
		$content .= "</tr>\n";
		$content .= "</table>\n";
	}
	
	return $content;
}

?>